#include "charge.h"

int intro_main = 0;


int checkmousehit(int x, int y, int w, int h)
{
	if (mousey > y && mousey <= y+h &&
		mousex > x && mousex <= x+w)
		return 1;
	return 0;
}

int textbutton(int id, int x, int y, const char *text)
{
	int w = (int)strlen(text) * 32;
	int h = 32;
	if (checkmousehit(x,y,w,h))
		gMouseOver = id;
	if (gMouseOver == id && gMouseActive == 0 && gMouseDown)
	{
		//int ch = FSOUND_PlaySound(FSOUND_FREE, gSampleMenuClick);
		//FSOUND_SetVolume(ch, (gSfxVolume * 255) / 100);
		gMouseActive = id;
	}

	drawrectb(x-4,y-4,w+8,h+8,0);

	blitstring32(x,y,text);
	if (gMouseOver == id)
	{
		drawrectb(x-4,y-4,w+8,h+8,0);
		blitstring32(x+1,y,text);
		blitstring32(x-1,y,text);
	}
	if (gMouseActive == id)
	{
		drawrectb(x-4,y-4,w+8,h+8,0);
		blitstring32(x+2,y,text);
		blitstring32(x-2,y,text);
	}

	if (gMouseOver == id && gMouseActive == id && !gMouseDown)
	{
		return 1;
	}

	return 0;	
}

void menu_render()
{
	int t = 500 - (SDL_GetTicks() - gStateStartTick);
	if (t < 0) t = 0;
	t = (int)(SMOOTHSTEP(t / 500.0f)*500);	

	if (intro_main == 0)
		intro_main = SDL_GetTicks();

	blit(gMenubg,0,0,800,600);

	blitstring(800 - (int)strlen(TITLE) * 8, 600-8,TITLE);

	gMouseOver = 0;

	if (textbutton(1,MainMenu.pos[0].x + t,MainMenu.pos[0].y,"Career"))
	{
		gCurrentCampaign = -1;
		changestate(STATE_SELECTCAMPAIGN);
	}
	if (textbutton(5,MainMenu.pos[1].x + t,MainMenu.pos[1].y,"Tutorial"))
	{
		gCurrentCampaign = 0;
		changestate(STATE_CAMPAIGN);
	}
	if (textbutton(3,MainMenu.pos[2].x + t,MainMenu.pos[2].y,"Single run"))
	{
		gCurrentCampaign = -2;
		changestate(STATE_SINGLE);
	}
	if (textbutton(7,MainMenu.pos[3].x + t,MainMenu.pos[3].y,"Options"))
	{
		changestate(STATE_OPTIONS);
	}
	if (textbutton(8,MainMenu.pos[4].x + t,MainMenu.pos[4].y,"Credits"))
	{
		changestate(STATE_CREDITS);
	}

	if (textbutton(4,MainMenu.pos[5].x + t,MainMenu.pos[5].y,"Quit"))
	{
		exit(0);
	}

	if (!gMouseDown) 
		gMouseActive = 0;

	blitcursor(mousex, mousey, 0); // selector cursor

	int introfade = SDL_GetTicks() - intro_main;
	if (introfade < 2000)
	{
		introfade = (255 - ((introfade * 255) / 2000)) * 0x010101;
		int i, j;
		for (i = 0; i < 600; i++)
		{
			int slofs = i * (gScreen->pitch / 4);
			for (j = 0; j < 800; j++, slofs++)
			{
				((unsigned int *)gScreen->pixels)[slofs] =
					blend_add(((unsigned int *)gScreen->pixels)[slofs], introfade);
			}
		}

	}

}


int menu_events()
{
	SDL_Delay(10);
	// Poll for events, and handle the ones we care about.
	SDL_Event event;
	while (SDL_PollEvent(&event)) 
	{
		switch (event.type) 
		{
		case SDL_MOUSEMOTION:
			// store mouse coordinates for use in render function
			mousex = event.motion.x;
			mousey = event.motion.y;
			break;
		case SDL_MOUSEBUTTONUP:
			gMouseDown = 0;
			break;
		case SDL_MOUSEBUTTONDOWN:
			gMouseDown = 1;
			break;
		case SDL_KEYUP:
			switch (event.key.keysym.sym)
			{
			case SDLK_ESCAPE:
				if (gGameState == STATE_MENU)
					return 0;
				else
				{
					if (gGameState == STATE_CAMPAIGN && gCurrentCampaign != 0)
					{
						changestate(STATE_SELECTCAMPAIGN);
					}
					else
					if (gGameState == STATE_CONFIRM)
					{
						changestate(STATE_OPTIONS);
					}
					else
					{
						changestate(STATE_MENU);
					}
				}
				break;
			}
			break;
		case SDL_QUIT:
			return(0);
		}
	}
	return 1;
}