#include "charge.h"

int slider(int id, int x, int y, int boxes, int boxsize, int boxspacing, int current)
{
	int i;
	int hit = -1;
	for (i = 0; i < boxes; i++)
	{
		if (checkmousehit(x + i * boxspacing, y, boxspacing, boxspacing))
			hit = i;
		int color = 0x7700;
		if (i == 0)
			color = 0x77;
		if (i >= current)
			color = 0x770000;
		if (hit == i)
			color <<= 1;
		blitrect(x + i * boxspacing, y, boxsize, boxsize, color);
	}
	if (hit != -1)
	{
		gMouseOver = hit * 1000 + id;
	}

	if (gMouseOver == (hit * 1000 + id) && gMouseActive == 0 && gMouseDown)
	{
//		int ch = FSOUND_PlaySound(FSOUND_FREE, gSampleMenuClick);
//		FSOUND_SetVolume(ch, (gSfxVolume * 255) / 100);
		gMouseActive = hit * 1000 + id;
	}

	if (gMouseOver == (hit * 1000 + id) && gMouseActive == (hit * 1000 + id) && !gMouseDown)
	{
		return hit + 1;
	}

	return 0;
}

void options_render()
{
	int t = 500 - (SDL_GetTicks() - gStateStartTick);
	if (t < 0) t = 0;
	t = (int)(SMOOTHSTEP(t / 500.0f)*500);	

	int q = 500 - (SDL_GetTicks() - gStateStartTick);
	if (q < 0) q = 0;
	q = (int)(SMOOTHSTEP(q / 500.0f)*500);	
	if (q > t) q = t;

	gMouseOver = 0;

	blit(gMenubg,0,0,800,600);
	drawrectb(0,180+t-4,800,40,0);
	drawrectb(0,180+t-4,800,40,0);
	blitstring32((800 - (int)strlen("Options") * 32) / 2,180+t,"Options");

	if (textbutton(1,50 + t,230,"Reset career"))
	{
		changestate(STATE_CONFIRM);
	}

	drawrectb(0+t,330-4,800,40,0);
	blitstring32(50+t,330,"Effect volume");

	int v;
	if (v = slider(299, 550 - t, 332, 6, 28, 32, gSfxVolume / 20 + 1))
	{
		gSfxVolume = (v - 1) * 20; // 0 - 5 -> 0 - 100
		set_state("sfxvolume", gSfxVolume + 1); // may not be zero as that's default
		serialize_states();
		//int ch = FSOUND_PlaySound(FSOUND_FREE, gSampleSmallEx);		
		//FSOUND_SetVolume(ch, (gSfxVolume * 255) / 100);
	}

	int replay = read_state("replay");
	if (textbutton(123,50 + t,380, replay?"Save replay always":"Save replay on hiscore"))
	{
		replay = !replay;
		set_state("replay", replay);
		serialize_states();
	}

	if (textbutton(4,OptionsMenu.pos.x + t,OptionsMenu.pos.y,"Back"))
	{
		changestate(STATE_MENU);
	}

	if (!gMouseDown) 
		gMouseActive = 0;

	blitcursor(mousex, mousey, 0); // selector cursor

}
