#include "charge.h"

void selectcampaign_render()
{
	int t = 500 - (SDL_GetTicks() - gStateStartTick);
	if (t < 0) t = 0;
	t = (int)(SMOOTHSTEP(t / 500.0f)*500);	

	int q = 500 - (SDL_GetTicks() - gStateStartTick);
	if (q < 0) q = 0;
	q = (int)(SMOOTHSTEP(q / 500.0f)*500);	
	if (q > t) q = t;

	gMouseOver = 0;

	blit(gMenubg,0,0,800,600);
	drawrectb(0,50+t-4,800,40,0);
	blitstring32((800 - (int)strlen("Select campaign") * 32) / 2,50+t,"Select campaign");

	if (textbutton(4,CareerMenu.pos.x + t,CareerMenu.pos.y,"Back"))
	{
		changestate(STATE_MENU);
	}

	int totalscore = 0;
	char temp[256];

	int i;
	for (i = 1; i < gCampaignCount; i++)
	{
		int ypos = (600 - 50 * gCampaignCount) / 2 + 50 * i;
		if (textbutton(4+i,200 + t,ypos, campaigninfo[i].name))
		{
			gCurrentCampaign = i;
			changestate(STATE_CAMPAIGN);
		}
		int sc = read_state(campaigninfo[i].filename);
		sprintf(temp,"%06d",sc);
		drawrectb(500 - t-4, ypos-4, 6*32+8,40,0);
		blitstring32(500 - t, ypos, temp);
		totalscore += sc;
	}
	int ypos = (600 - 50 * gCampaignCount) / 2 + 50 * i;
	sprintf(temp,"%06d", totalscore);
	drawrectb(0,ypos - 11 - t,800, 4, 0); 
	drawrect(0,ypos - 10 - t,800, 2, 0); 
	drawrectb(500 - t-4, ypos-4, 6*32+8,40,0);
	blitstring32(500 - t, ypos, temp);

	drawrectb(200-4-t,100-4,400+8,8*5+8,0);

	int totaltime, totalmissions, totalwon, totaldug;
	totaltime = read_state("totalplayingtime");
	totaldug = read_state("totaldug");
	totalmissions = read_state("missionsplayed");
	totalwon = read_state("missionswon");
	sprintf(temp, "Total playing time: %d:%02d:%02d", totaltime / (60*60), (totaltime / 60) % 60, totaltime % 60);
	blitstring(200-t,100,temp);
	float wonpercent = 0;
	if (totalmissions > 0)
		wonpercent = ((float)totalwon / totalmissions) * 100;
	sprintf(temp, "Missions played: %d - missions won: %d (%3.2f%%)", totalmissions, totalwon, wonpercent);
	blitstring(200-t,116,temp);
	sprintf(temp, "Total ground dug - about %d%s (or %d whole maps)", totaldug, totaldug?"000":"",totaldug / 408);
	blitstring(200-t,132,temp);

	if (!gMouseDown) 
		gMouseActive = 0;

	blitcursor(mousex, mousey, 0); // selector cursor

}
