#include "charge.h"

void confirm_render()
{
	int tick = SDL_GetTicks();
	int t = 500 - (tick - gStateStartTick);
	if (t < 0) t = 0;
	t = (int)(SMOOTHSTEP(t / 500.0f)*500);	

	int q = 500 - (tick - gStateStartTick);
	if (q < 0) q = 0;
	q = (int)(SMOOTHSTEP(q / 500.0f)*500);	
	if (q > t) q = t;

	gMouseOver = 0;

	blit(gMenubg,0,0,800,600);
	drawrectb(0,0-t,800,600,0);
	drawrectb(0,50+t-4,800,40,0);
	blitstring32((800 - (int)strlen("Confirm reset") * 32) / 2, 50+t, "Confirm reset");

	drawrectb(40 - t - 8,150 - 8,23*32+16,6*32+16, (int)(sin(tick * 0.0043847) * 0x7f + 0x7f) << 16 );
	blitstring32(40 - t, 150, "Note!");
	blitstring32(40 - t, 150+32, "Reseting the career");
	blitstring32(40 - t, 150+64, "sets all scores to zero");
	blitstring32(40 - t, 150+96, "and locks all levels");
	blitstring32(40 - t, 150+128, "(and resets options to");
	blitstring32(40 - t, 150+160, "default values too)");

	if (textbutton(543,(800-14*32)/2 + t,425,"Yes, wipe away"))
	{
		wipe_states();
		serialize_states();
		changestate(STATE_OPTIONS);
	}

	if (textbutton(654,(800-20*32)/2 + t,500, "No, I don't think so"))
	{
		changestate(STATE_OPTIONS);
	}

	if (!gMouseDown) 
		gMouseActive = 0;

	blitcursor(mousex, mousey, 0); // selector cursor

}
