#include "charge.h"

void splash_render()
{	
	int tick = SDL_GetTicks() - gStateStartTick;

	if (tick > 8000)
	{
		changestate(STATE_MENU);
	}

	int t = tick / 10;
	if (t > 300) t = 300;
	drawrect(0,300 - t,800,t * 2,0xffffff);

	if (tick > 3700)
	{
		blit(gSplash,(int)(sin((tick - 3700) * 0.032987) * 3700 * exp(-(tick - 3700) * 0.003f)),0,800,600);
	}
}

int splash_events()
{
	// Poll for events, and handle the ones we care about.
	SDL_Event event;
	while (SDL_PollEvent(&event)) 
	{
		switch (event.type) 
		{
		case SDL_MOUSEBUTTONUP:
		case SDL_KEYUP:
			changestate(STATE_MENU);
			break;
		case SDL_QUIT:
			return(0);
		}
	}
	return 1;
}